// Exemple d'accs aux UDT (relationnel-objet) par la classe STRUCT
import java.sql.*;
import java.util.*;
import oracle.sql.*;
import oracle.jdbc.*;
import java.math.*;

public class ExempleUDTEnStruct 
{
  public static void main (String args []) throws Exception {
    // Cration d'une Connection globale pour l'application
    UsineConnection uneUsineConnection = new UsineConnection();
    Connection uneConnection = uneUsineConnection.getConnectionSansAutoCommit(
            "oracle.jdbc.driver.OracleDriver",
            "jdbc:oracle:thin:@localhost:1521:orcl",
            "godin","oracle");
    try{
        // Recherche de la rfrence au LivreType ISBN = '0-201-12227-8'
        PreparedStatement unPreparedStatement = uneConnection.prepareStatement
        ("SELECT REF(l) AS refLivre FROM Livre l WHERE l.ISBN = '0-201-12227-8'");
        ResultSet unResultSet = unPreparedStatement.executeQuery();
        
        if (unResultSet.next()){
          // Conversion de la rfrence  l'UDT LivreType sous forme d'un objet Java REF
          REF ref = (REF) unResultSet.getObject(1);

          // Extraire l'objet LivreType rfrenc sous forme d'un STRUCT
          STRUCT unLivreSTRUCT = (STRUCT) ref.getValue();

          // Recherche des attributs du UDT LivreType sous forme d'un tableau d'objets
          Object attributsDeLivre[] = unLivreSTRUCT.getAttributes();

          // Cast des attributs selon leur type 
          System.out.println("ISBN :"+(String)attributsDeLivre[0]); // ISBN CHAR(13)
          System.out.println("titre :"+(String)attributsDeLivre[1]); // titre VARCHAR(50)

          // L'attribut anneParution est un UDT extrait en STRUCT
          STRUCT uneAnneParutionSTRUCT = (STRUCT) attributsDeLivre[2]; // anneParution TypeDonnesAnne
          Object attributsDeAnneParution[] = uneAnneParutionSTRUCT.getAttributes();
          System.out.println((BigDecimal)attributsDeAnneParution[0]); // valeurAnne INTEGER

          // L'attribut diteur est un REF  EditeurType
          REF refEditeur = (REF)attributsDeLivre[3]; // diteur REF EditeurType

          // Extraire le l'objet EditeurType rfrenc sous forme de STRUCT
          STRUCT unEditeurSTRUCT = (STRUCT) refEditeur.getValue();

          // Recherche des attributs du UDT EditeurType
          Object attributsDeEditeur[] = unEditeurSTRUCT.getAttributes();
          System.out.println("nomEditeur :"+(String)attributsDeEditeur[0]); // nomEditeur VARCHAR(20)
          System.out.println("ville :"+(String)attributsDeEditeur[1]); // ville VARCHAR(20)

          // Suivre les rfrences inverses
          // L'attribut lesLivres est une table enchsse extraite sous forme d'ARRAY
          ARRAY laTableEnchasse =  (ARRAY)attributsDeEditeur[2]; //lesLivres tableRefLivresType

          // Extraire les lments sous forme de tableau d'objets
          Object[] lesLivres = (Object[])laTableEnchasse.getArray();

          // Parcours de la table enchsse
          for (int i=0; i<lesLivres.length;i++){
            // Chacun des lments de la table enchsse est un UDT LivreRefType converti en STRUCT
            STRUCT unREFLivreStruct = (STRUCT) lesLivres[i];
            Object attributsDeREFLivreStruct[] = unREFLivreStruct.getAttributes();
            REF refLivre = (REF)attributsDeREFLivreStruct[0]; // livreRef REF LivreType

          // Extraire l'objet LivreType rfrenc sous forme d'un STRUCT
            STRUCT unAutreLivreSTRUCT = (STRUCT) refLivre.getValue();

          // Recherche des attributs du UDT
          Object attributsDeAutreLivre[] = unAutreLivreSTRUCT.getAttributes();

          // Cast des attributs selon leur type 
          System.out.println("ISBN :"+(String)attributsDeAutreLivre[0]); // ISBN CHAR(13)
          System.out.println("titre :"+(String)attributsDeAutreLivre[1]); // titre VARCHAR(50)        
          }       
        }else{
            throw new Exception("Livre inexistant");
        }
    }
    catch(Exception lException){
            lException.printStackTrace();
    }
    finally{
            uneConnection.commit();
            uneConnection.close();
            System.exit(0);
    }
  }
}