import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class LivreTypeRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "GODIN.LIVRETYPE";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

  private static final LivreTypeRef _LivreTypeRefFactory = new LivreTypeRef();

  public static ORADataFactory getORADataFactory()
  { return _LivreTypeRefFactory; }
  /* constructor */
  public LivreTypeRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    LivreTypeRef r = new LivreTypeRef();
    r._ref = (REF) d;
    return r;
  }

  public LivreType getValue() throws SQLException
  {
     return (LivreType) LivreType.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(LivreType c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
